import { Authenticator } from './index';
import { TokenCache } from './TokenCache';
/**
 * An Authenticator class for the OAuth 2.0 Client Credentials grant.
 */
export declare class ClientCredentials extends Authenticator {
    private clientId;
    private clientSecret;
    private authServer;
    private baseUrl;
    constructor(clientId: string, clientSecret: string, tokenCache?: TokenCache, authServer?: string, baseUrl?: string);
    /**
     * This method fetches an access token using the OAuth 2.0 Client Credentials grant and returns it
     */
    fetchAccessToken(): Promise<{
        accessToken: string;
        expiresIn: number;
    }>;
}
