import { Authenticator, TokenCache } from './';
/**
 * An Authenticator class for the OAuth 2.0 Authorization Code with PKCE grant.
 */
export declare class PKCE extends Authenticator {
    private clientId;
    private callback;
    private authServer?;
    private baseUrl;
    constructor(clientId: string, callback: string, authServer?: string | undefined, tokenCache?: TokenCache, baseUrl?: string);
    private checkForCallback;
    fetchAccessToken(): Promise<undefined>;
    private authorize;
    tradeCodeForToken(code: string, state: string): Promise<void>;
}
/**
 * Crypto stuff for PKCE
 * Most of this is taken from: https://github.com/auth0/auth0-spa-js (MIT licensed)
 */
export declare const getCrypto: () => Crypto;
export declare const getCryptoSubtle: () => SubtleCrypto;
export declare const createRandomString: () => string;
export declare const sha256: (s: string) => Promise<any>;
export declare const bufferToBase64UrlEncoded: (input: number[] | Uint8Array) => string;
