"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bufferToBase64UrlEncoded = exports.sha256 = exports.createRandomString = exports.getCryptoSubtle = exports.getCrypto = exports.PKCE = void 0;
var _1 = require("./");
var utils_1 = require("../utils");
var utils_2 = require("../utils");
var TokenCache_1 = require("./TokenCache");
var __1 = require("..");
/**
 * An Authenticator class for the OAuth 2.0 Authorization Code with PKCE grant.
 */
var PKCE = /** @class */ (function (_super) {
    __extends(PKCE, _super);
    function PKCE(
    // Client ID for your application, can be generated by an Spinque system administrator upon request.
    clientId, 
    // The callback URL to your application, this must be known by the Spinque Authorization server, contact system administrator if this changes.
    callback, 
    // URL to the Spinque Authorization server, default is https://login.spinque.com/
    authServer, 
    // Optional path to store the authentication token and make it persistent through server/page reloads
    tokenCache, 
    // URL to the Spinque Query API, used as OAuth 2.0 scope, default is https://rest.spinque.com/
    baseUrl) {
        if (tokenCache === void 0) { tokenCache = TokenCache_1.localStorageTokenCache; }
        if (baseUrl === void 0) { baseUrl = __1.DEFAULT_BASE_URL; }
        var _this = _super.call(this, tokenCache) || this;
        _this.clientId = clientId;
        _this.callback = callback;
        _this.authServer = authServer;
        _this.baseUrl = baseUrl;
        if (!utils_2.isBrowser) {
            throw new Error('PKCE is only available for browser applications');
        }
        // Immediately check whether we're on the callback page
        _this.checkForCallback();
        return _this;
    }
    PKCE.prototype.checkForCallback = function () {
        var _this = this;
        if (!window || !window.location) {
            throw new Error('Cannot retrieve current location to check authentication callback');
        }
        // TODO: should check if domain and path match callback URL, not just get query params
        // Get query parameters from URL
        var params = Object.fromEntries(new URLSearchParams(window.location.search).entries());
        if (!params['code'] || !params['state']) {
            return;
        }
        this._authInProgress = true;
        this.tradeCodeForToken(params['code'], params['state']).catch(function () { return _this.authorize(); });
    };
    PKCE.prototype.fetchAccessToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.authorize()];
            });
        });
    };
    PKCE.prototype.authorize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var authServer, audience, verifier, challenge, _a, state, params, authorizationUrl;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        authServer = this.authServer || _1.DEFAULT_AUTH_SERVER;
                        audience = this.baseUrl || __1.DEFAULT_BASE_URL;
                        verifier = (0, exports.createRandomString)();
                        _a = exports.bufferToBase64UrlEncoded;
                        return [4 /*yield*/, (0, exports.sha256)(verifier)];
                    case 1:
                        challenge = _a.apply(void 0, [_b.sent()]);
                        state = (0, exports.createRandomString)();
                        // Store the verifier and state so we can access it again after navigating the user to login.spinque.com
                        localStorage.setItem('@spinque/query-api/pkce-verifier', verifier);
                        localStorage.setItem('@spinque/query-api/pkce-state', state);
                        params = {
                            response_type: 'code',
                            code_challenge: challenge,
                            code_challenge_method: 'S256',
                            client_id: this.clientId,
                            redirect_uri: this.callback,
                            audience: audience,
                            scope: '',
                            state: state,
                        };
                        authorizationUrl = (0, utils_1.join)(authServer, 'authorize');
                        authorizationUrl += "?".concat(Object.entries(params)
                            .map(function (_a) {
                            var _b = __read(_a, 2), key = _b[0], value = _b[1];
                            return "".concat(key, "=").concat(value);
                        })
                            .join('&'));
                        window.location.href = authorizationUrl;
                        return [2 /*return*/, new Promise(function () { })];
                }
            });
        });
    };
    PKCE.prototype.tradeCodeForToken = function (code, state) {
        return __awaiter(this, void 0, void 0, function () {
            var storedState, verifier, authServer, body, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._accessToken) {
                            return [2 /*return*/];
                        }
                        storedState = localStorage.getItem('@spinque/query-api/pkce-state');
                        if (storedState !== state) {
                            throw new Error('PKCE state parameter does not match expected value.');
                        }
                        verifier = localStorage.getItem('@spinque/query-api/pkce-verifier');
                        if (!verifier) {
                            throw new Error('Unable to find code verifier in local storage.');
                        }
                        authServer = this.authServer || _1.DEFAULT_AUTH_SERVER;
                        body = {
                            grant_type: 'authorization_code',
                            client_id: this.clientId,
                            code_verifier: verifier,
                            redirect_uri: this.callback,
                            code: code,
                        };
                        return [4 /*yield*/, fetch((0, utils_1.join)(authServer, 'oauth', 'token'), {
                                method: 'POST',
                                headers: new Headers({ 'Content-Type': 'application/x-www-form-urlencoded' }),
                                body: Object.entries(body)
                                    .map(function (_a) {
                                    var _b = __read(_a, 2), key = _b[0], value = _b[1];
                                    return "".concat(key, "=").concat(value);
                                })
                                    .join('&'),
                            })];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 2:
                        json = _a.sent();
                        if (!(response.status === 403 && json && json.error && json.error === 'invalid_grant')) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.fetchAccessToken()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        if (response.status !== 200 || !json || !json.access_token || !json.expires_in) {
                            throw new Error(json.error_description || json.error || response.status);
                        }
                        this.setAccessToken(json.access_token, json.expires_in);
                        return [2 /*return*/];
                }
            });
        });
    };
    return PKCE;
}(_1.Authenticator));
exports.PKCE = PKCE;
/**
 * Crypto stuff for PKCE
 * Most of this is taken from: https://github.com/auth0/auth0-spa-js (MIT licensed)
 */
var getCrypto = function () {
    return (window.crypto || window.msCrypto);
};
exports.getCrypto = getCrypto;
var getCryptoSubtle = function () {
    var crypto = (0, exports.getCrypto)();
    return crypto.subtle || crypto.webkitSubtle;
};
exports.getCryptoSubtle = getCryptoSubtle;
var createRandomString = function () {
    var charset = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-_~.';
    var random = '';
    var randomValues = Array.from((0, exports.getCrypto)().getRandomValues(new Uint8Array(43)));
    randomValues.forEach(function (v) { return (random += charset[v % charset.length]); });
    return random;
};
exports.createRandomString = createRandomString;
var sha256 = function (s) { return __awaiter(void 0, void 0, void 0, function () {
    var digestOp;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                digestOp = (0, exports.getCryptoSubtle)().digest({ name: 'SHA-256' }, new TextEncoder().encode(s));
                if (window.msCrypto) {
                    return [2 /*return*/, new Promise(function (res, rej) {
                            digestOp.oncomplete = function (e) {
                                res(e.target.result);
                            };
                            digestOp.onerror = function (e) {
                                rej(e.error);
                            };
                            digestOp.onabort = function () {
                                rej('The digest operation was aborted');
                            };
                        })];
                }
                return [4 /*yield*/, digestOp];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.sha256 = sha256;
var bufferToBase64UrlEncoded = function (input) {
    var ie11SafeInput = new Uint8Array(input);
    return urlEncodeB64(window.btoa(String.fromCharCode.apply(String, __spreadArray([], __read(Array.from(ie11SafeInput)), false))));
};
exports.bufferToBase64UrlEncoded = bufferToBase64UrlEncoded;
var urlEncodeB64 = function (input) {
    var b64Chars = { '+': '-', '/': '_', '=': '' };
    return input.replace(/[+/=]/g, function (m) { return b64Chars[m]; });
};
//# sourceMappingURL=PKCE.js.map