/**
 * Interface to implement token caching.
 */
export interface TokenCache {
    /**
     * Get a token and expiration timestamp from storage.
     */
    get: () => {
        accessToken: string;
        expires: number;
    } | null;
    /**
     * Put a token and expiration timestamp into storage.
     */
    set: (token: string, expires: number) => void;
}
/**
 * Implementation of TokenCache that uses localStorage to cache tokens.
 */
export declare const localStorageTokenCache: TokenCache;
