import { Query, ResultItem, ResultsResponse, SpinqueResultObject } from './types';
export interface Cluster {
    probability: number;
    rank: number;
    class: string[];
    query: Query;
}
interface GetClustersOptions {
    clusterEndpoint?: string;
    clusterParameterName?: string;
    clusterParameterType?: 'STRING' | 'TUPLE_LIST';
    knownClusters?: string[];
}
/**
 * Taskes a ResultsResponse, finds clusters in the results and returns a list of Cluster objects.
 * These Cluster objects contain a Query that can be used to fetch the contents of the clusters
 * by stacking the Query on top of the results Query[].
 */
export declare const getClusters: (results: ResultsResponse, options?: GetClustersOptions) => Cluster[];
/**
 * Takes a result item and checks if it is a cluster.
 * A result is considered a cluster when it's of type rdfs:Class.
 */
export declare const isCluster: (item: ResultItem) => item is ResultItem<[SpinqueResultObject]>;
export {};
