import { ApiConfig, Query } from '.';
import { RequestOptions, RequestType } from './types';
/**
 * Takes an array of Query objects and returns the path they would represent in a Query API request URL.
 */
export declare const pathFromQueries: (queries: Query[]) => string;
/**
 * Takes a Query and returns the path it would represent in a Query API request URL.
 */
export declare const pathFromQuery: (query: Query) => string;
/**
 * Takes an ApiConfig object and returns the URL to fetch API details
 */
export declare const apiUrl: (config: ApiConfig) => string;
/**
 * Takes an ApiConfig object and returns the URL to fetch API status
 */
export declare const apiStatusUrl: (config: ApiConfig) => string;
/**
 * Takes an ApiConfig object and array of Query objects and returns a Query API request URL.
 */
export declare const urlFromQueries: (config: ApiConfig, queries: Query | Query[], options?: RequestOptions | undefined, requestType?: RequestType) => string;
/**
 * Given a tuple list (and optionally scores), return a string representation.
 */
export declare const stringToTupleList: (value: string) => {
    scores: number[];
    tuples: (string | number)[][];
} | null;
/**
 * Given a string, try to parse as tuple list.
 */
export declare const tupleListToString: (tuples: (string | number)[][] | (string | number)[] | string | number, scores?: number[] | undefined) => string;
/**
 * Joins together URL parts into an URL
 */
export declare const join: (...segments: string[]) => string;
/**
 * Expects a string generated by stringifyQueries and returns an array of Query's
 */
export declare const parseQueries: (stringified: string) => Query[];
/**
 * Expects an array of Query's and turns them into a string
 */
export declare const stringifyQueries: (queries: Query[]) => string;
export declare const isBrowser: boolean;
